package examples.dataloader;


import com.aliyun.odps.account.Account;
import com.aliyun.odps.account.AliyunAccount;
import com.aliyun.odps.data.Record;
import com.tzld.piaoquan.recommend.feature.domain.ad.base.AdActionFeature;
import com.tzld.piaoquan.recommend.feature.domain.ad.base.AdRequestContext;
import com.tzld.piaoquan.recommend.feature.domain.ad.base.UserAdFeature;
import com.tzld.piaoquan.recommend.feature.domain.ad.base.AdItemFeature;


import java.util.HashMap;
import java.util.Map;

public class AdRedisFeatureConstructor {

    private static final String BUCKET_NAME = "ali-recommend";
    private static final Map<String, String> ODPS_CONFIG = new HashMap<String, String>();

    static {
        ODPS_CONFIG.put("ENDPOINT", "http://service.cn.maxcompute.aliyun.com/api");
        ODPS_CONFIG.put("ACCESSID", "LTAIWYUujJAm7CbH");
        ODPS_CONFIG.put("ACCESSKEY", "RfSjdiWwED1sGFlsjXv0DlfTnZTG1P");
    }

    ;

    private static final Account account = new AliyunAccount(ODPS_CONFIG.get("ACCESSID"), ODPS_CONFIG.get("ACCESSKEY"));


    public static UserAdFeature constructUserFeature(Record record) {
        UserAdFeature userFeature = new UserAdFeature();
        userFeature.setMid(record.getString("mids"));

        // 1day features
        AdActionFeature userAd1dayActionFeature = new AdActionFeature();
        userAd1dayActionFeature.setAdView(record.getString("ad_view_1day"));
        userAd1dayActionFeature.setAdClick(record.getString("ad_click_1day"));
        userAd1dayActionFeature.setAdConversion(record.getString("ad_conversion_1day"));
        userAd1dayActionFeature.setCtr(record.getString("ad_ctr_1day"));
        userAd1dayActionFeature.setCvr(record.getString("ad_cvr_1day"));
        userFeature.setDay1_cnt_features(userAd1dayActionFeature);


        // 3day features
        AdActionFeature userAd3dayActionFeature = new AdActionFeature();
        userAd3dayActionFeature.setAdView(record.getString("ad_view_3day"));
        userAd3dayActionFeature.setAdClick(record.getString("ad_click_3day"));
        userAd3dayActionFeature.setAdConversion(record.getString("ad_conversion_3day"));
        userAd3dayActionFeature.setCtr(record.getString("ad_ctr_3day"));
        userAd3dayActionFeature.setCvr(record.getString("ad_cvr_3day"));
        userFeature.setDay3_cnt_features(userAd3dayActionFeature);


        // 7day features
        AdActionFeature userAd7dayActionFeature = new AdActionFeature();
        userAd7dayActionFeature.setAdView(record.getString("ad_view_7day"));
        userAd7dayActionFeature.setAdClick(record.getString("ad_click7day"));
        userAd7dayActionFeature.setAdConversion(record.getString("ad_conversion_7day"));
        userAd7dayActionFeature.setCtr(record.getString("ad_ctr_7day"));
        userAd7dayActionFeature.setCvr(record.getString("ad_cvr_7day"));
        userFeature.setDay7_cnt_features(userAd7dayActionFeature);


        // 3month features
        AdActionFeature userAd3MonthActionFeature = new AdActionFeature();
        userAd3MonthActionFeature.setAdView(record.getString("ad_view_3month"));
        userAd3MonthActionFeature.setAdClick(record.getString("ad_click_3month"));
        userAd3MonthActionFeature.setAdConversion(record.getString("ad_conversion_3month"));
        userAd3MonthActionFeature.setCtr(record.getString("ad_ctr_3month"));
        userAd3MonthActionFeature.setCvr(record.getString("ad_cvr_3month"));
        userFeature.setMonth3_cnt_features(userAd3MonthActionFeature);


        return userFeature;
    }


    public static AdItemFeature constructItemFeature(Record record) {
        AdItemFeature itemFeature = new AdItemFeature();
        itemFeature.setAdId(record.getString("creativeid"));
        // itemFeature.setAdCode(record.getString("adcode"));
        itemFeature.setCampaignId(record.getString("campaignid"));
        itemFeature.setAdvertiserId(record.getString("advertiserid"));
        itemFeature.setCreativeId(record.getString("creativeid"));

        // ad 维度特征
        AdActionFeature adIdActionFeature1day = new AdActionFeature();
        adIdActionFeature1day.setAdView(record.getString("view_ad_1day"));
        adIdActionFeature1day.setAdClick(record.getString("click_ad_1day"));
        adIdActionFeature1day.setAdConversion(record.getString("conversion_ad_1day"));
        adIdActionFeature1day.setCtr(record.getString("ctr_ad_1day"));
        adIdActionFeature1day.setCvr(record.getString("cvr_ad_1day"));
        itemFeature.setDay1_cnt_features(adIdActionFeature1day);

        AdActionFeature adIdActionFeature3day = new AdActionFeature();
        adIdActionFeature3day.setAdView(record.getString("view_ad_3day"));
        adIdActionFeature3day.setAdClick(record.getString("click_ad_3day"));
        adIdActionFeature3day.setAdConversion(record.getString("conversion_ad_3day"));
        adIdActionFeature3day.setCtr(record.getString("ctr_ad_3day"));
        adIdActionFeature3day.setCvr(record.getString("cvr_ad_3day"));
        itemFeature.setDay3_cnt_features(adIdActionFeature3day);

        AdActionFeature adIdActionFeature7day = new AdActionFeature();
        adIdActionFeature7day.setAdView(record.getString("view_ad_7day"));
        adIdActionFeature7day.setAdClick(record.getString("click_ad_7day"));
        adIdActionFeature7day.setAdConversion(record.getString("conversion_ad_7day"));
        adIdActionFeature7day.setCtr(record.getString("ctr_ad_7day"));
        adIdActionFeature7day.setCvr(record.getString("cvr_ad_7day"));
        itemFeature.setDay7_cnt_features(adIdActionFeature7day);

        AdActionFeature adIdActionFeature3month = new AdActionFeature();
        adIdActionFeature3month.setAdView(record.getString("view_ad_3month"));
        adIdActionFeature3month.setAdClick(record.getString("click_ad_3month"));
        adIdActionFeature3month.setAdConversion(record.getString("conversion_ad_3month"));
        adIdActionFeature3month.setCtr(record.getString("ctr_ad_3month"));
        adIdActionFeature3month.setCvr(record.getString("cvr_ad_3month"));
        itemFeature.setMonth3_cnt_features(adIdActionFeature3month);

        // TODO creativeId等维度特征
        // creative 维度特征
        AdActionFeature creativeActionFeature1day = new AdActionFeature();
        creativeActionFeature1day.setAdView(record.getString("view_creative_1day"));
        creativeActionFeature1day.setAdClick(record.getString("click_creative_1day"));
        creativeActionFeature1day.setAdConversion(record.getString("conversion_creative_1day"));
        creativeActionFeature1day.setCtr(record.getString("ctr_creative_1day"));
        creativeActionFeature1day.setCvr(record.getString("cvr_creative_1day"));
        itemFeature.setCreative_1day_cnt_features(creativeActionFeature1day);

        AdActionFeature creativeActionFeature3day = new AdActionFeature();
        creativeActionFeature3day.setAdView(record.getString("view_creative_3day"));
        creativeActionFeature3day.setAdClick(record.getString("click_creative_3day"));
        creativeActionFeature3day.setAdConversion(record.getString("conversion_creative_3day"));
        creativeActionFeature3day.setCtr(record.getString("ctr_creative_3day"));
        creativeActionFeature3day.setCvr(record.getString("cvr_creative_3day"));
        itemFeature.setCreative_3day_cnt_features(creativeActionFeature3day);

        AdActionFeature creativeActionFeature7day = new AdActionFeature();
        creativeActionFeature7day.setAdView(record.getString("view_creative_7day"));
        creativeActionFeature7day.setAdClick(record.getString("click_creative_7day"));
        creativeActionFeature7day.setAdConversion(record.getString("conversion_creative_7day"));
        creativeActionFeature7day.setCtr(record.getString("ctr_creative_7day"));
        creativeActionFeature7day.setCvr(record.getString("cvr_creative_7day"));
        itemFeature.setCreative_7day_cnt_features(creativeActionFeature7day);


        AdActionFeature creativeActionFeature3month = new AdActionFeature();
        creativeActionFeature3month.setAdView(record.getString("view_creative_3month"));
        creativeActionFeature3month.setAdClick(record.getString("click_creative_3month"));
        creativeActionFeature3month.setAdConversion(record.getString("conversion_creative_3month"));
        creativeActionFeature3month.setCtr(record.getString("ctr_creative_3month"));
        creativeActionFeature3month.setCvr(record.getString("cvr_creative_3month"));
        itemFeature.setCreative_3month_cnt_features(creativeActionFeature3month);



        // TODO advertiser维度
        // advertiser 维度特征
        AdActionFeature advidActionFeature1day = new AdActionFeature();
        advidActionFeature1day.setAdView(record.getString("view_advertiser_1day"));
        advidActionFeature1day.setAdClick(record.getString("click_advertiser_1day"));
        advidActionFeature1day.setAdConversion(record.getString("conversion_advertiser_1day"));
        advidActionFeature1day.setCtr(record.getString("ctr_advertiser_1day"));
        advidActionFeature1day.setCvr(record.getString("cvr_advertiser_1day"));
        itemFeature.setAdvertiser_1day_cnt_features(advidActionFeature1day);

        AdActionFeature advidActionFeature3day = new AdActionFeature();
        advidActionFeature3day.setAdView(record.getString("view_advertiser_3day"));
        advidActionFeature3day.setAdClick(record.getString("click_advertiser_3day"));
        advidActionFeature3day.setAdConversion(record.getString("conversion_advertiser_3day"));
        advidActionFeature3day.setCtr(record.getString("ctr_advertiser_3day"));
        advidActionFeature3day.setCvr(record.getString("cvr_advertiser_3day"));
        itemFeature.setAdvertiser_3day_cnt_features(advidActionFeature3day);

        AdActionFeature advidActionFeature7day = new AdActionFeature();
        advidActionFeature7day.setAdView(record.getString("view_advertiser_7day"));
        advidActionFeature7day.setAdClick(record.getString("click_advertiser_7day"));
        advidActionFeature7day.setAdConversion(record.getString("conversion_advertiser_7day"));
        advidActionFeature7day.setCtr(record.getString("ctr_advertiser_7day"));
        advidActionFeature7day.setCvr(record.getString("cvr_advertiser_7day"));
        itemFeature.setAdvertiser_7day_cnt_features(advidActionFeature7day);


        AdActionFeature advidActionFeature3month = new AdActionFeature();
        advidActionFeature3month.setAdView(record.getString("view_advertiser_3month"));
        advidActionFeature3month.setAdClick(record.getString("click_advertiser_3month"));
        advidActionFeature3month.setAdConversion(record.getString("conversion_advertiser_3month"));
        advidActionFeature3month.setCtr(record.getString("ctr_advertiser_3month"));
        advidActionFeature3month.setCvr(record.getString("cvr_advertiser_3month"));
        itemFeature.setAdvertiser_3month_cnt_features(advidActionFeature3month);



        return itemFeature;
    }


}
